(* Dead code elimination in less than 30 LOC *)
open Sprog 

module StringSet = Set.Make (String)

let uses_of_operand = function 
    Lit _ -> [ ]
  | Var x -> [x]

let defs_and_uses_of_stmt = function 
    Input x -> x, []
  | ValBinop (x, _, o1, o2) -> 
      x, (uses_of_operand o1)@(uses_of_operand o2)

let dce ((stmts, e) as eprog) = 
  let def_list, use_lists_pre = 
      List.map defs_and_uses_of_stmt stmts |> List.split in 
  let use_lists = uses_of_operand e :: use_lists_pre in 
  let def_set = StringSet.of_list def_list in 
  let use_set = StringSet.of_list (List.concat use_lists) in 
  let unused_set = StringSet.diff def_set use_set in 
  if StringSet.is_empty unused_set 
    then eprog 
    else List.filter_map 
           (fun st -> match st with 
              ValBinop (x,_, _,_) when StringSet.mem x unused_set 
                -> None 
            | _ -> Some st )
            stmts, e