(* Constant Folding Optimization, Simplified translation *)
open Sprog 

let const_fold_do_nothing x = x

let subst_oper env = function 
   Lit n -> Lit n
 | Var x  -> 
      match List.assoc_opt x env with 
        None -> Var x 
      | Some op -> op
      
let f_op = let open Eprog in function 
    Add -> ( + ) | Sub -> ( - ) | Mul -> ( * ) | Div -> ( / )

let const_fold_stmt_1 env stmt = 
   match stmt with 
   | ValBinop (x, op, Lit a, Lit b) -> 
        (x, Lit ((f_op op) a b)) :: env,
        stmt (* keep the statement, even though it's dead code *)
   | ValBinop (x, op, o1, o2) -> 
        env, 
        ValBinop (x, op, subst_oper env o1, subst_oper env o2)
   | Input _ -> env, stmt

let const_fold_stmt_1 (stmts, e) = 
   let env', stmts'  = List.fold_left_map const_fold_stmt_1 [] stmts in 
   let e' = subst_oper env' e in 
   (stmts', e')

