(* Defining the type for binary operations *)
type binop =
  | Add | Sub | Mul | Div

type varname = string

(* Defining the type for arithmetic Eprogessions *)
type expr =
  | Int of int                       (* Integer constant *)
  | BinOp of binop * expr * expr     (* Binary operation *)
  | Var of varname                   (* Variable lookup  *)


(* Defining the type of statements *)  
type estmt = 
  | Val of varname * expr
  | Input of varname   

(* Eprogession program is a list of statements 
   followed by an Eprogession *) 
type eprog = estmt list * expr
 