open Sprog

module type SimpleRewriter = sig 
  type env
  val empty : env 
  val rewrite_stmt : env -> sstmt -> sstmt option * env 
  val rewrite_oper : env -> operand -> operand
end 


module Make (S: SimpleRewriter) = struct 
  let traverse (stmts, e) = 
    let stmts', env = 
      List.fold_left 
          (fun (ii,env) stmt -> 
              match S.rewrite_stmt env stmt with 
                None, env' -> ii, env' 
              | Some i, env' -> i::ii, env' 
          ) 
          ([], S.empty)
          stmts in 
    (List.rev stmts', S.rewrite_oper env e)
end 